#ifndef YERBACON_LEX_H
#define YERBACON_LEX_H

#include <vector>
#include "Yerbacon.hpp"
#include <limits>
#include <ostream>

struct tok {
    class LexerException: public Yerbacon::Exception {
        using Yerbacon::Exception::Exception;
    };
    enum type: const unsigned short {
        UNEXPECTED = std::numeric_limits<unsigned char>::max() + 1, IDENTIFIER, NUMBER, ALPHACHAR, SEPARATOR,
        DEFINE = '=', TAG = '#', DOLLAR_SIGN = '$', DOT = '.',
        PLUS = '+', LPAR = '(', LBRACE = '{', LBRACKET = '[', RPAR = ')',
        RBRACE = '}', RBRACKET = ']',
        HYPHEN = '-', LCOMP = '>', RCOMP = '<',
        SQUOTE = '\'',
        STRING = '"',
    };
    const type toktype;
    const std::string toktext;
    const unsigned long line = 0;
    tok(type Type, std::string_view Text, decltype(line) line): toktype(Type), toktext(Text), line(line) {}
    friend std::ostream& operator<<(std::ostream& output, const tok& it) { return output << it.toktext; }
};
std::vector<tok> lex(const std::string& in, char separatorCharacter);

#endif //YERBACON_TEST_H